/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Contents of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.30 - (hide annotations) (download)
Thu Jul 14 19:33:52 2005 UTC (8 years, 9 months ago) by johnm
Branch: MAIN
Changes since 1.29: +18 -3 lines
closes bug #98721 - localversions not handled correctly

1 johnm 1.1 # Copyright 1999-2004 Gentoo Foundation
2     # Distributed under the terms of the GNU General Public License v2
3 johnm 1.30 # $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.29 2005/07/11 15:08:06 swegener Exp $
4 johnm 1.1 #
5 johnm 1.10 # Description: This eclass is used as a central eclass for accessing kernel
6     # related information for sources already installed.
7     # It is vital for linux-mod to function correctly, and is split
8     # out so that any ebuild behaviour "templates" are abstracted out
9     # using additional eclasses.
10 johnm 1.1 #
11 johnm 1.10 # Maintainer: John Mylchreest <johnm@gentoo.org>
12     # Copyright 2004 Gentoo Linux
13     #
14     # Please direct your bugs to the current eclass maintainer :)
15    
16     # A Couple of env vars are available to effect usage of this eclass
17     # These are as follows:
18 swegener 1.29 #
19 johnm 1.21 # Env Var Option Description
20 johnm 1.10 # KERNEL_DIR <string> The directory containing kernel the target kernel
21 johnm 1.21 # sources.
22 johnm 1.10 # CONFIG_CHECK <string> a list of .config options to check for before
23 johnm 1.21 # proceeding with the install. ie: CONFIG_CHECK="MTRR"
24 swegener 1.29 # You can also check that an option doesn't exist by
25 johnm 1.21 # prepending it with an exclamation mark (!).
26     # ie: CONFIG_CHECK="!MTRR"
27     # ERROR_CFG <string> The error message to display when the above check
28     # fails. <CFG> should reference the appropriate option
29 johnm 1.25 # as above. ie: ERROR_MTRR="MTRR exists in the .config
30 johnm 1.21 # but shouldn't!!"
31 johnm 1.10 # KBUILD_OUTPUT <string> This is passed on commandline, or can be set from
32 johnm 1.21 # the kernel makefile. This contains the directory
33     # which is to be used as the kernel object directory.
34 johnm 1.10
35     # There are also a couple of variables which are set by this, and shouldn't be
36     # set by hand. These are as follows:
37 swegener 1.29 #
38 johnm 1.10 # Env Var Option Description
39     # KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1
40     # KV_MAJOR <integer> The kernel major version. ie: 2
41     # KV_MINOR <integer> The kernel minor version. ie: 6
42     # KV_PATCH <integer> The kernel patch version. ie: 9
43     # KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo
44     # KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm
45     # KV_DIR <string> The kernel source directory, will be null if
46 johnm 1.21 # KERNEL_DIR is invalid.
47     # KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless
48     # koutput is used. This should be used for referencing
49     # .config.
50 johnm 1.10
51 johnm 1.21 # And to ensure all the weirdness with crosscompile
52 johnm 1.23 inherit toolchain-funcs versionator
53 johnm 1.1
54 johnm 1.8 EXPORT_FUNCTIONS pkg_setup
55 johnm 1.1
56     # Overwritable environment Var's
57     # ---------------------------------------
58 johnm 1.21 KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
59 johnm 1.1
60 johnm 1.7
61 johnm 1.16 # Bug fixes
62     # fix to bug #75034
63     case ${ARCH} in
64 swegener 1.29 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
65     ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
66 johnm 1.16 esac
67    
68 johnm 1.21 # These are legacy wrappers for toolchain-funcs.
69     # I dont like them here, but oh well.
70 johnm 1.22 set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; }
71     set_arch_to_portage() { export ARCH="$(tc-arch)"; }
72 johnm 1.11
73     # qeinfo "Message"
74     # -------------------
75 johnm 1.21 # qeinfo is a quiet einfo call when EBUILD_PHASE
76 johnm 1.11 # should not have visible output.
77 johnm 1.21 qout() {
78     local outputmsg type
79     type=${1}
80     shift
81     outputmsg="${@}"
82 wolf31o2 1.26 case "${EBUILD_PHASE}" in
83     depend) unset outputmsg;;
84     clean) unset outputmsg;;
85     preinst) unset outputmsg;;
86     esac
87     [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
88 johnm 1.11 }
89    
90 johnm 1.21 qeinfo() { qout einfo "${@}" ; }
91     qeerror() { qout eerror "${@}" ; }
92 johnm 1.11
93 johnm 1.1 # File Functions
94     # ---------------------------------------
95    
96     # getfilevar accepts 2 vars as follows:
97     # getfilevar <VARIABLE> <CONFIGFILE>
98    
99     getfilevar() {
100 johnm 1.21 local ERROR workingdir basefname basedname myARCH="${ARCH}"
101 johnm 1.1 ERROR=0
102 johnm 1.16
103 johnm 1.1 [ -z "${1}" ] && ERROR=1
104     [ ! -f "${2}" ] && ERROR=1
105    
106     if [ "${ERROR}" = 1 ]
107     then
108 johnm 1.6 echo -e "\n"
109 johnm 1.1 eerror "getfilevar requires 2 variables, with the second a valid file."
110     eerror " getfilevar <VARIABLE> <CONFIGFILE>"
111     else
112 johnm 1.6 workingdir=${PWD}
113     basefname=$(basename ${2})
114     basedname=$(dirname ${2})
115     unset ARCH
116 johnm 1.21
117 johnm 1.6 cd ${basedname}
118 johnm 1.7 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
119 johnm 1.24 make ${BUILD_FIXES} -s -f - e 2>/dev/null
120 johnm 1.6 cd ${workingdir}
121 johnm 1.21
122     ARCH=${myARCH}
123 johnm 1.1 fi
124     }
125    
126 johnm 1.7 linux_chkconfig_present() {
127 johnm 1.1 local RESULT
128 johnm 1.7 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
129 johnm 1.1 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
130     }
131    
132 johnm 1.7 linux_chkconfig_module() {
133 johnm 1.1 local RESULT
134 johnm 1.7 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
135 johnm 1.1 [ "${RESULT}" = "m" ] && return 0 || return 1
136     }
137    
138 johnm 1.7 linux_chkconfig_builtin() {
139 johnm 1.1 local RESULT
140 johnm 1.7 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
141 johnm 1.1 [ "${RESULT}" = "y" ] && return 0 || return 1
142     }
143    
144 johnm 1.7 linux_chkconfig_string() {
145     getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config"
146     }
147    
148 johnm 1.1 # Versioning Functions
149     # ---------------------------------------
150    
151     # kernel_is returns true when the version is the same as the passed version
152     #
153     # For Example where KV = 2.6.9
154     # kernel_is 2 4 returns false
155     # kernel_is 2 returns true
156     # kernel_is 2 6 returns true
157     # kernel_is 2 6 8 returns false
158     # kernel_is 2 6 9 returns true
159 johnm 1.3 #
160 johnm 1.1 # got the jist yet?
161    
162     kernel_is() {
163     # if we haven't determined the version yet, we need too.
164     get_version;
165 johnm 1.23 local operator test value x=0 y=0 z=0
166    
167     case ${1} in
168     lt) operator="-lt"; shift;;
169     gt) operator="-gt"; shift;;
170     le) operator="-le"; shift;;
171     ge) operator="-ge"; shift;;
172     eq) operator="-eq"; shift;;
173     *) operator="-eq";;
174     esac
175    
176     for x in ${@}; do
177     for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
178     value="${value}${x}"
179     z=$((${z} + 1))
180    
181     case ${z} in
182     1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
183     test="${test}${KV_MAJOR}";;
184     2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
185     test="${test}${KV_MINOR}";;
186     3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
187     test="${test}${KV_PATCH}";;
188     *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
189     esac
190     done
191 johnm 1.12
192 swegener 1.29 [ ${test} ${operator} ${value} ] && return 0 || return 1
193 johnm 1.1 }
194    
195 johnm 1.30 get_localversion() {
196     local lv_list i x
197    
198     # ignore files with ~ in it.
199     for i in $(ls ${1}/localversion* 2>/dev/null); do
200     [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
201     done
202    
203     for i in ${lv_list}; do
204     x="${x}$(<${i})"
205     done
206     x=${x/ /}
207     echo ${x}
208     }
209    
210 johnm 1.1 get_version() {
211 johnm 1.4 local kbuild_output
212 swegener 1.29
213 johnm 1.1 # no need to execute this twice assuming KV_FULL is populated.
214     # we can force by unsetting KV_FULL
215 johnm 1.19 [ -n "${KV_FULL}" ] && return 0
216 johnm 1.1
217     # if we dont know KV_FULL, then we need too.
218     # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
219     unset KV_DIR
220    
221     # KV_DIR will contain the full path to the sources directory we should use
222 johnm 1.11 qeinfo "Determining the location of the kernel source code"
223 johnm 1.1 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
224     [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
225 swegener 1.29
226 johnm 1.1 if [ -z "${KV_DIR}" ]
227     then
228 johnm 1.11 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
229     qeinfo "This package requires Linux sources."
230 johnm 1.7 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
231 johnm 1.11 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
232     qeinfo "(or the kernel you wish to build against)."
233     qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
234 johnm 1.7 else
235 johnm 1.11 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
236 johnm 1.7 fi
237 johnm 1.19 return 1
238 johnm 1.7 fi
239    
240 johnm 1.11 qeinfo "Found kernel source directory:"
241     qeinfo " ${KV_DIR}"
242 johnm 1.7
243     if [ ! -s "${KV_DIR}/Makefile" ]
244     then
245 johnm 1.11 qeerror "Could not find a Makefile in the kernel source directory."
246     qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
247 johnm 1.19 return 1
248 johnm 1.7 fi
249 swegener 1.29
250 johnm 1.4 # OK so now we know our sources directory, but they might be using
251     # KBUILD_OUTPUT, and we need this for .config and localversions-*
252     # so we better find it eh?
253     # do we pass KBUILD_OUTPUT on the CLI?
254     OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
255 swegener 1.29
256 johnm 1.6 # And if we didn't pass it, we can take a nosey in the Makefile
257 johnm 1.4 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)"
258     OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
259 swegener 1.29
260 johnm 1.1 # And contrary to existing functions I feel we shouldn't trust the
261     # directory name to find version information as this seems insane.
262     # so we parse ${KV_DIR}/Makefile
263     KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)"
264     KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)"
265     KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)"
266     KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)"
267 swegener 1.29
268 johnm 1.7 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
269     then
270 johnm 1.11 qeerror "Could not detect kernel version."
271 johnm 1.19 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
272     return 1
273 johnm 1.7 fi
274 swegener 1.29
275 johnm 1.1 # and in newer versions we can also pull LOCALVERSION if it is set.
276 johnm 1.4 # but before we do this, we need to find if we use a different object directory.
277     # This *WILL* break if the user is using localversions, but we assume it was
278     # caught before this if they are.
279     [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \
280 johnm 1.7 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}"
281 johnm 1.4
282     [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
283     [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
284     if [ -n "${KV_OUT_DIR}" ];
285     then
286 johnm 1.11 qeinfo "Found kernel object directory:"
287     qeinfo " ${KV_OUT_DIR}"
288 swegener 1.29
289 johnm 1.30 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
290 johnm 1.4 fi
291     # and if we STILL haven't got it, then we better just set it to KV_DIR
292     KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
293 johnm 1.21
294 johnm 1.30 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_OUT_DIR})"
295 johnm 1.7 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
296     KV_LOCAL="${KV_LOCAL//\"/}"
297 johnm 1.21
298 johnm 1.1 # And we should set KV_FULL to the full expanded version
299     KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
300 johnm 1.21
301 johnm 1.11 qeinfo "Found sources for kernel version:"
302     qeinfo " ${KV_FULL}"
303 johnm 1.21
304 johnm 1.9 if [ ! -s "${KV_OUT_DIR}/.config" ]
305     then
306 johnm 1.11 qeerror "Could not find a usable .config in the kernel source directory."
307 johnm 1.12 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
308     qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
309     qeerror "it points to the necessary object directory so that it might find .config."
310 johnm 1.19 return 1
311 johnm 1.9 fi
312 johnm 1.21
313 johnm 1.19 return 0
314 johnm 1.1 }
315    
316 johnm 1.23 get_running_version() {
317     KV_FULL=$(uname -r)
318 johnm 1.1
319 johnm 1.23 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
320     KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
321     unset KV_FULL
322     get_version
323     return $?
324     elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
325     KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
326     unset KV_FULL
327     get_version
328     return $?
329     else
330     KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
331     KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
332     KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
333     KV_PATCH=${KV_PATCH//-*}
334     [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
335     && KV_EXTRA="-${KV_FULL#*-}"
336     fi
337     return 0
338     }
339 johnm 1.1
340    
341     # ebuild check functions
342     # ---------------------------------------
343    
344     check_kernel_built() {
345     # if we haven't determined the version yet, we need too.
346     get_version;
347 swegener 1.29
348 johnm 1.16 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
349 johnm 1.1 then
350 johnm 1.16 eerror "These sources have not yet been prepared."
351     eerror "We cannot build against an unprepared tree."
352 johnm 1.1 eerror "To resolve this, please type the following:"
353     eerror
354     eerror "# cd ${KV_DIR}"
355     eerror "# make oldconfig"
356 johnm 1.16 eerror "# make modules_prepare"
357 johnm 1.1 eerror
358     eerror "Then please try merging this module again."
359     die "Kernel sources need compiling first"
360     fi
361     }
362    
363     check_modules_supported() {
364     # if we haven't determined the version yet, we need too.
365     get_version;
366 swegener 1.29
367 johnm 1.7 if ! linux_chkconfig_builtin "MODULES"
368 johnm 1.1 then
369     eerror "These sources do not support loading external modules."
370     eerror "to be able to use this module please enable \"Loadable modules support\""
371     eerror "in your kernel, recompile and then try merging this module again."
372 johnm 1.7 die "No support for external modules in ${KV_FULL} config"
373 johnm 1.3 fi
374     }
375    
376     check_extra_config() {
377 johnm 1.17 local config negate error local_error i n temp_config
378 johnm 1.3
379     # if we haven't determined the version yet, we need too.
380     get_version;
381    
382     einfo "Checking for suitable kernel configuration options"
383     for config in ${CONFIG_CHECK}
384     do
385     negate="${config:0:1}"
386     if [ "${negate}" == "!" ];
387     then
388     config="${config:1}"
389 johnm 1.7 if linux_chkconfig_present ${config}
390 johnm 1.3 then
391 johnm 1.7 local_error="${config}_ERROR"
392     local_error="${!local_error}"
393     [ -n "${local_error}" ] && eerror " ${local_error}" || \
394     eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
395 johnm 1.3 error=1
396     fi
397 johnm 1.17 elif [ "${negate}" == "@" ];
398     then
399     # we never call this unless we are using MODULE_NAMES
400    
401     config="${config:1}"
402     temp_config="${config//*:}"
403     config="${config//:*}"
404     if linux_chkconfig_present ${config}
405     then
406     local_error="${config}_ERROR"
407     local_error="${!local_error}"
408     [ -n "${local_error}" ] && eerror " ${local_error}" || \
409     eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
410    
411     for i in ${MODULE_NAMES}
412     do
413     n="${i//${temp_config}}"
414 johnm 1.18 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
415 johnm 1.17 done
416     error=0
417     fi
418 johnm 1.3 else
419 johnm 1.7 if ! linux_chkconfig_present ${config}
420 johnm 1.3 then
421 johnm 1.21 # Support the new syntax first.
422     local_error="ERROR_${config}"
423 johnm 1.7 local_error="${!local_error}"
424 swegener 1.29
425 johnm 1.21 # then fall back on the older syntax.
426     if [[ -z ${local_error} ]] ; then
427     local_error="${config}_ERROR"
428     local_error="${!local_error}"
429     fi
430 swegener 1.29
431 johnm 1.21 [[ -n ${local_error} ]] && eerror " ${local_error}" || \
432 johnm 1.7 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't"
433 johnm 1.3 error=1
434     fi
435     fi
436     done
437    
438 johnm 1.17 if [ "${error}" == 1 ] ;
439 johnm 1.3 then
440     eerror "Please check to make sure these options are set correctly."
441     eerror "Once you have satisfied these options, please try merging"
442     eerror "this package again."
443 johnm 1.7 die "Incorrect kernel configuration options"
444 johnm 1.1 fi
445     }
446    
447     check_zlibinflate() {
448     # if we haven't determined the version yet, we need too.
449     get_version;
450 swegener 1.29
451 johnm 1.1 # although I restructured this code - I really really really dont support it!
452    
453     # bug #27882 - zlib routines are only linked into the kernel
454     # if something compiled into the kernel calls them
455     #
456     # plus, for the cloop module, it appears that there's no way
457     # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
458     # is on
459 swegener 1.29
460     local INFLATE
461     local DEFLATE
462 johnm 1.1
463     einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
464 swegener 1.29
465 johnm 1.1 ebegin "checking ZLIB_INFLATE"
466     getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config
467     eend $?
468     [ "$?" != 0 ] && die
469 swegener 1.29
470 johnm 1.1 ebegin "checking ZLIB_DEFLATE"
471     getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config
472     eend $?
473     [ "$?" != 0 ] && die
474 swegener 1.29
475 johnm 1.1 local LINENO_START
476     local LINENO_END
477     local SYMBOLS
478     local x
479 swegener 1.29
480 johnm 1.1 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
481     LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
482     (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
483     (( LINENO_END = $LINENO_END - 1 ))
484 johnm 1.4 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
485 johnm 1.1
486     # okay, now we have a list of symbols
487     # we need to check each one in turn, to see whether it is set or not
488     for x in $SYMBOLS ; do
489     if [ "${!x}" = "y" ]; then
490     # we have a winner!
491     einfo "${x} ensures zlib is linked into your kernel - excellent"
492     return 0
493     fi
494     done
495 swegener 1.29
496 johnm 1.1 eerror
497     eerror "This kernel module requires ZLIB library support."
498     eerror "You have enabled zlib support in your kernel, but haven't enabled"
499     eerror "enabled any option that will ensure that zlib is linked into your"
500     eerror "kernel."
501     eerror
502     eerror "Please ensure that you enable at least one of these options:"
503     eerror
504    
505     for x in $SYMBOLS ; do
506     eerror " * $x"
507     done
508    
509     eerror
510     eerror "Please remember to recompile and install your kernel, and reboot"
511     eerror "into your new kernel before attempting to load this kernel module."
512    
513     die "Kernel doesn't include zlib support"
514     }
515 johnm 1.8
516     ################################
517     # Default pkg_setup
518     # Also used when inheriting linux-mod to force a get_version call
519    
520     linux-info_pkg_setup() {
521 johnm 1.19 get_version || die "Unable to calculate Linux Kernel version"
522 johnm 1.10 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
523 johnm 1.8 }

  ViewVC Help
Powered by ViewVC 1.1.20